/*
 * URL Shortener API
 * This API is responsible of authetication and the creation, modification and deletion of uris and hooks.
 *
 * OpenAPI spec version: 0.2.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.9
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD.
    define(['expect.js', '../../src/index'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    factory(require('expect.js'), require('../../src/index'));
  } else {
    // Browser globals (root is window)
    factory(root.expect, root.UrlShortenerApi);
  }
}(this, function(expect, UrlShortenerApi) {
  'use strict';

  var instance;

  beforeEach(function() {
    instance = new UrlShortenerApi.HookApi();
  });

  describe('(package)', function() {
    describe('HookApi', function() {
      describe('activateHook', function() {
        it('should call activateHook successfully', function(done) {
          // TODO: uncomment, update parameter values for activateHook call and complete the assertions
          /*
          var hookId = 789;

          instance.activateHook(hookId, function(error, data, response) {
            if (error) {
              done(error);
              return;
            }
            // TODO: update response assertions
            expect(data).to.be.a(UrlShortenerApi.Hook);
            expect(data.hookId).to.be.a('number');
            expect(data.hookId).to.be("0");
            expect(data.userId).to.be.a('number');
            expect(data.userId).to.be("0");
            expect(data.uriId).to.be.a('string');
            expect(data.uriId).to.be("");
            expect(data.active).to.be.a('boolean');
            expect(data.active).to.be(false);
            expect(data.trigger).to.be.a(UrlShortenerApi.HookTrigger);
                  expect(data.trigger.clicks).to.be.a('number');
              expect(data.trigger.clicks).to.be(0);
              expect(data.trigger.minutes).to.be.a('number');
              expect(data.trigger.minutes).to.be(0);
            {
              let dataCtr = data.actionsHTTP;
              expect(dataCtr).to.be.an(Array);
              expect(dataCtr).to.not.be.empty();
              for (let p in dataCtr) {
                let data = dataCtr[p];
                expect(data).to.be.a(UrlShortenerApi.HookActionHTTP);
                expect(data.endpoint).to.be.a('string');
                expect(data.endpoint).to.be("");
                expect(data.verb).to.be.a('string');
                expect(data.verb).to.be("");
                expect(data.params).to.be.a('string');
                expect(data.params).to.be("");
                expect(data.body).to.be.a(Object);
                expect(data.body).to.be();
              }
            }
            {
              let dataCtr = data.actionsMail;
              expect(dataCtr).to.be.an(Array);
              expect(dataCtr).to.not.be.empty();
              for (let p in dataCtr) {
                let data = dataCtr[p];
                expect(data).to.be.a(UrlShortenerApi.HookActionMail);
                {
                  let dataCtr = data.destinations;
                  expect(dataCtr).to.be.an(Array);
                  expect(dataCtr).to.not.be.empty();
                  for (let p in dataCtr) {
                    let data = dataCtr[p];
                    expect(data).to.be.a('string');
                    expect(data).to.be("");
                  }
                }
                expect(data.subject).to.be.a('string');
                expect(data.subject).to.be("");
                expect(data.text).to.be.a('string');
                expect(data.text).to.be("");
              }
            }

            done();
          });
          */
          // TODO: uncomment and complete method invocation above, then delete this line and the next:
          done();
        });
      });
      describe('createHook', function() {
        it('should call createHook successfully', function(done) {
          // TODO: uncomment, update parameter values for createHook call and complete the assertions
          /*
          var body = new UrlShortenerApi.HookRequest();
          body.uriId = "";
          body.trigger = new UrlShortenerApi.HookTrigger();
          body.trigger.clicks = 0;
          body.trigger.minutes = 0;
          body.actionsHTTP = [new UrlShortenerApi.HookActionHTTP()];
          body.actionsHTTP[0].endpoint = "";
          body.actionsHTTP[0].verb = "";
          body.actionsHTTP[0].params = "";
          body.actionsHTTP[0].body = ;
          body.actionsMail = [new UrlShortenerApi.HookActionMail()];
          body.actionsMail[0].destinations = [""];
          body.actionsMail[0].subject = "";
          body.actionsMail[0].text = "";

          instance.createHook(body, function(error, data, response) {
            if (error) {
              done(error);
              return;
            }
            // TODO: update response assertions
            expect(data).to.be.a(UrlShortenerApi.Hook);
            expect(data.hookId).to.be.a('number');
            expect(data.hookId).to.be("0");
            expect(data.userId).to.be.a('number');
            expect(data.userId).to.be("0");
            expect(data.uriId).to.be.a('string');
            expect(data.uriId).to.be("");
            expect(data.active).to.be.a('boolean');
            expect(data.active).to.be(false);
            expect(data.trigger).to.be.a(UrlShortenerApi.HookTrigger);
                  expect(data.trigger.clicks).to.be.a('number');
              expect(data.trigger.clicks).to.be(0);
              expect(data.trigger.minutes).to.be.a('number');
              expect(data.trigger.minutes).to.be(0);
            {
              let dataCtr = data.actionsHTTP;
              expect(dataCtr).to.be.an(Array);
              expect(dataCtr).to.not.be.empty();
              for (let p in dataCtr) {
                let data = dataCtr[p];
                expect(data).to.be.a(UrlShortenerApi.HookActionHTTP);
                expect(data.endpoint).to.be.a('string');
                expect(data.endpoint).to.be("");
                expect(data.verb).to.be.a('string');
                expect(data.verb).to.be("");
                expect(data.params).to.be.a('string');
                expect(data.params).to.be("");
                expect(data.body).to.be.a(Object);
                expect(data.body).to.be();
              }
            }
            {
              let dataCtr = data.actionsMail;
              expect(dataCtr).to.be.an(Array);
              expect(dataCtr).to.not.be.empty();
              for (let p in dataCtr) {
                let data = dataCtr[p];
                expect(data).to.be.a(UrlShortenerApi.HookActionMail);
                {
                  let dataCtr = data.destinations;
                  expect(dataCtr).to.be.an(Array);
                  expect(dataCtr).to.not.be.empty();
                  for (let p in dataCtr) {
                    let data = dataCtr[p];
                    expect(data).to.be.a('string');
                    expect(data).to.be("");
                  }
                }
                expect(data.subject).to.be.a('string');
                expect(data.subject).to.be("");
                expect(data.text).to.be.a('string');
                expect(data.text).to.be("");
              }
            }

            done();
          });
          */
          // TODO: uncomment and complete method invocation above, then delete this line and the next:
          done();
        });
      });
      describe('deactivateHook', function() {
        it('should call deactivateHook successfully', function(done) {
          // TODO: uncomment, update parameter values for deactivateHook call and complete the assertions
          /*
          var hookId = 789;

          instance.deactivateHook(hookId, function(error, data, response) {
            if (error) {
              done(error);
              return;
            }
            // TODO: update response assertions
            expect(data).to.be.a(UrlShortenerApi.Hook);
            expect(data.hookId).to.be.a('number');
            expect(data.hookId).to.be("0");
            expect(data.userId).to.be.a('number');
            expect(data.userId).to.be("0");
            expect(data.uriId).to.be.a('string');
            expect(data.uriId).to.be("");
            expect(data.active).to.be.a('boolean');
            expect(data.active).to.be(false);
            expect(data.trigger).to.be.a(UrlShortenerApi.HookTrigger);
                  expect(data.trigger.clicks).to.be.a('number');
              expect(data.trigger.clicks).to.be(0);
              expect(data.trigger.minutes).to.be.a('number');
              expect(data.trigger.minutes).to.be(0);
            {
              let dataCtr = data.actionsHTTP;
              expect(dataCtr).to.be.an(Array);
              expect(dataCtr).to.not.be.empty();
              for (let p in dataCtr) {
                let data = dataCtr[p];
                expect(data).to.be.a(UrlShortenerApi.HookActionHTTP);
                expect(data.endpoint).to.be.a('string');
                expect(data.endpoint).to.be("");
                expect(data.verb).to.be.a('string');
                expect(data.verb).to.be("");
                expect(data.params).to.be.a('string');
                expect(data.params).to.be("");
                expect(data.body).to.be.a(Object);
                expect(data.body).to.be();
              }
            }
            {
              let dataCtr = data.actionsMail;
              expect(dataCtr).to.be.an(Array);
              expect(dataCtr).to.not.be.empty();
              for (let p in dataCtr) {
                let data = dataCtr[p];
                expect(data).to.be.a(UrlShortenerApi.HookActionMail);
                {
                  let dataCtr = data.destinations;
                  expect(dataCtr).to.be.an(Array);
                  expect(dataCtr).to.not.be.empty();
                  for (let p in dataCtr) {
                    let data = dataCtr[p];
                    expect(data).to.be.a('string');
                    expect(data).to.be("");
                  }
                }
                expect(data.subject).to.be.a('string');
                expect(data.subject).to.be("");
                expect(data.text).to.be.a('string');
                expect(data.text).to.be("");
              }
            }

            done();
          });
          */
          // TODO: uncomment and complete method invocation above, then delete this line and the next:
          done();
        });
      });
      describe('deleteHook', function() {
        it('should call deleteHook successfully', function(done) {
          // TODO: uncomment, update parameter values for deleteHook call
          /*
          var hookId = 789;

          instance.deleteHook(hookId, function(error, data, response) {
            if (error) {
              done(error);
              return;
            }

            done();
          });
          */
          // TODO: uncomment and complete method invocation above, then delete this line and the next:
          done();
        });
      });
      describe('getHook', function() {
        it('should call getHook successfully', function(done) {
          // TODO: uncomment, update parameter values for getHook call and complete the assertions
          /*
          var hookId = 789;

          instance.getHook(hookId, function(error, data, response) {
            if (error) {
              done(error);
              return;
            }
            // TODO: update response assertions
            expect(data).to.be.a(UrlShortenerApi.Hook);
            expect(data.hookId).to.be.a('number');
            expect(data.hookId).to.be("0");
            expect(data.userId).to.be.a('number');
            expect(data.userId).to.be("0");
            expect(data.uriId).to.be.a('string');
            expect(data.uriId).to.be("");
            expect(data.active).to.be.a('boolean');
            expect(data.active).to.be(false);
            expect(data.trigger).to.be.a(UrlShortenerApi.HookTrigger);
                  expect(data.trigger.clicks).to.be.a('number');
              expect(data.trigger.clicks).to.be(0);
              expect(data.trigger.minutes).to.be.a('number');
              expect(data.trigger.minutes).to.be(0);
            {
              let dataCtr = data.actionsHTTP;
              expect(dataCtr).to.be.an(Array);
              expect(dataCtr).to.not.be.empty();
              for (let p in dataCtr) {
                let data = dataCtr[p];
                expect(data).to.be.a(UrlShortenerApi.HookActionHTTP);
                expect(data.endpoint).to.be.a('string');
                expect(data.endpoint).to.be("");
                expect(data.verb).to.be.a('string');
                expect(data.verb).to.be("");
                expect(data.params).to.be.a('string');
                expect(data.params).to.be("");
                expect(data.body).to.be.a(Object);
                expect(data.body).to.be();
              }
            }
            {
              let dataCtr = data.actionsMail;
              expect(dataCtr).to.be.an(Array);
              expect(dataCtr).to.not.be.empty();
              for (let p in dataCtr) {
                let data = dataCtr[p];
                expect(data).to.be.a(UrlShortenerApi.HookActionMail);
                {
                  let dataCtr = data.destinations;
                  expect(dataCtr).to.be.an(Array);
                  expect(dataCtr).to.not.be.empty();
                  for (let p in dataCtr) {
                    let data = dataCtr[p];
                    expect(data).to.be.a('string');
                    expect(data).to.be("");
                  }
                }
                expect(data.subject).to.be.a('string');
                expect(data.subject).to.be("");
                expect(data.text).to.be.a('string');
                expect(data.text).to.be("");
              }
            }

            done();
          });
          */
          // TODO: uncomment and complete method invocation above, then delete this line and the next:
          done();
        });
      });
      describe('getHooksByURI', function() {
        it('should call getHooksByURI successfully', function(done) {
          // TODO: uncomment, update parameter values for getHooksByURI call and complete the assertions
          /*
          var uriId = "uriId_example";

          instance.getHooksByURI(uriId, function(error, data, response) {
            if (error) {
              done(error);
              return;
            }
            // TODO: update response assertions
            let dataCtr = data;
            expect(dataCtr).to.be.an(Array);
            expect(dataCtr).to.not.be.empty();
            for (let p in dataCtr) {
              let data = dataCtr[p];
              expect(data).to.be.a(UrlShortenerApi.Hook);
              expect(data.hookId).to.be.a('number');
              expect(data.hookId).to.be("0");
              expect(data.userId).to.be.a('number');
              expect(data.userId).to.be("0");
              expect(data.uriId).to.be.a('string');
              expect(data.uriId).to.be("");
              expect(data.active).to.be.a('boolean');
              expect(data.active).to.be(false);
              expect(data.trigger).to.be.a(UrlShortenerApi.HookTrigger);
                    expect(data.trigger.clicks).to.be.a('number');
                expect(data.trigger.clicks).to.be(0);
                expect(data.trigger.minutes).to.be.a('number');
                expect(data.trigger.minutes).to.be(0);
              {
                let dataCtr = data.actionsHTTP;
                expect(dataCtr).to.be.an(Array);
                expect(dataCtr).to.not.be.empty();
                for (let p in dataCtr) {
                  let data = dataCtr[p];
                  expect(data).to.be.a(UrlShortenerApi.HookActionHTTP);
                  expect(data.endpoint).to.be.a('string');
                  expect(data.endpoint).to.be("");
                  expect(data.verb).to.be.a('string');
                  expect(data.verb).to.be("");
                  expect(data.params).to.be.a('string');
                  expect(data.params).to.be("");
                  expect(data.body).to.be.a(Object);
                  expect(data.body).to.be();
                }
              }
              {
                let dataCtr = data.actionsMail;
                expect(dataCtr).to.be.an(Array);
                expect(dataCtr).to.not.be.empty();
                for (let p in dataCtr) {
                  let data = dataCtr[p];
                  expect(data).to.be.a(UrlShortenerApi.HookActionMail);
                  {
                    let dataCtr = data.destinations;
                    expect(dataCtr).to.be.an(Array);
                    expect(dataCtr).to.not.be.empty();
                    for (let p in dataCtr) {
                      let data = dataCtr[p];
                      expect(data).to.be.a('string');
                      expect(data).to.be("");
                    }
                  }
                  expect(data.subject).to.be.a('string');
                  expect(data.subject).to.be("");
                  expect(data.text).to.be.a('string');
                  expect(data.text).to.be("");
                }
              }
            }

            done();
          });
          */
          // TODO: uncomment and complete method invocation above, then delete this line and the next:
          done();
        });
      });
      describe('updateHook', function() {
        it('should call updateHook successfully', function(done) {
          // TODO: uncomment, update parameter values for updateHook call and complete the assertions
          /*
          var hookId = 789;
          var body = new UrlShortenerApi.HookRequest();
          body.uriId = "";
          body.trigger = new UrlShortenerApi.HookTrigger();
          body.trigger.clicks = 0;
          body.trigger.minutes = 0;
          body.actionsHTTP = [new UrlShortenerApi.HookActionHTTP()];
          body.actionsHTTP[0].endpoint = "";
          body.actionsHTTP[0].verb = "";
          body.actionsHTTP[0].params = "";
          body.actionsHTTP[0].body = ;
          body.actionsMail = [new UrlShortenerApi.HookActionMail()];
          body.actionsMail[0].destinations = [""];
          body.actionsMail[0].subject = "";
          body.actionsMail[0].text = "";

          instance.updateHook(hookId, body, function(error, data, response) {
            if (error) {
              done(error);
              return;
            }
            // TODO: update response assertions
            expect(data).to.be.a(UrlShortenerApi.Hook);
            expect(data.hookId).to.be.a('number');
            expect(data.hookId).to.be("0");
            expect(data.userId).to.be.a('number');
            expect(data.userId).to.be("0");
            expect(data.uriId).to.be.a('string');
            expect(data.uriId).to.be("");
            expect(data.active).to.be.a('boolean');
            expect(data.active).to.be(false);
            expect(data.trigger).to.be.a(UrlShortenerApi.HookTrigger);
                  expect(data.trigger.clicks).to.be.a('number');
              expect(data.trigger.clicks).to.be(0);
              expect(data.trigger.minutes).to.be.a('number');
              expect(data.trigger.minutes).to.be(0);
            {
              let dataCtr = data.actionsHTTP;
              expect(dataCtr).to.be.an(Array);
              expect(dataCtr).to.not.be.empty();
              for (let p in dataCtr) {
                let data = dataCtr[p];
                expect(data).to.be.a(UrlShortenerApi.HookActionHTTP);
                expect(data.endpoint).to.be.a('string');
                expect(data.endpoint).to.be("");
                expect(data.verb).to.be.a('string');
                expect(data.verb).to.be("");
                expect(data.params).to.be.a('string');
                expect(data.params).to.be("");
                expect(data.body).to.be.a(Object);
                expect(data.body).to.be();
              }
            }
            {
              let dataCtr = data.actionsMail;
              expect(dataCtr).to.be.an(Array);
              expect(dataCtr).to.not.be.empty();
              for (let p in dataCtr) {
                let data = dataCtr[p];
                expect(data).to.be.a(UrlShortenerApi.HookActionMail);
                {
                  let dataCtr = data.destinations;
                  expect(dataCtr).to.be.an(Array);
                  expect(dataCtr).to.not.be.empty();
                  for (let p in dataCtr) {
                    let data = dataCtr[p];
                    expect(data).to.be.a('string');
                    expect(data).to.be("");
                  }
                }
                expect(data.subject).to.be.a('string');
                expect(data.subject).to.be("");
                expect(data.text).to.be.a('string');
                expect(data.text).to.be("");
              }
            }

            done();
          });
          */
          // TODO: uncomment and complete method invocation above, then delete this line and the next:
          done();
        });
      });
    });
  });

}));
